// ===============================================================
// CBP_1421_Helper2.c
// 30-12-20
//
// ===============================================================
#include <webots/camera.h>

#define DEBUG false

int imageSegment(const unsigned char *image,unsigned char *imageThresh, int width, int height) {
  
  int count = 0;
  double minsat = 1.5;
  double maxsat = 0;
  for (int i = 0; i < width ; i++) {
    for (int j = 0; j < height; j++) {
      double red = wb_camera_image_get_red(image, width, i, j);
      double green = wb_camera_image_get_green(image, width, i, j);
      double blue = wb_camera_image_get_blue(image, width, i, j);  
      
      // Find and remove white light pollution
      
      double min = 255;
      if(red < min)
        min = red;
      if(green < min)
        min = green;
      if(blue < min)
        min = blue;
       double intens = red + green + blue;
       
       double sat = (intens - min)/intens;
       if(sat < minsat)
         minsat = sat;
       if(sat > maxsat)
         maxsat = sat;         
      red -= min;
      blue -= min;
      green -= min;
                     
      double sum = red + green + blue + 0.000001;
      red = red/sum;
      green = green/sum;
      blue = blue/sum;
      
      double numi=0.5*((red - green)+(red - blue));
      double denom=sqrt((red-green)*(red - green)+ (red-blue)*(green - blue));
      double hue = acos(numi/(denom + 0.0000001))*180/M_PI;
      if(blue > green) hue = 360-hue;   
      //printf("Sat = %f\n",sat);
      // 4 bytes per pixel in the image. Offset 1 is red
      *(imageThresh + i*4 +     	j*width*4) = 0;
      *(imageThresh + i*4 + 1 + j*width*4) = 0;
      *(imageThresh + i*4 + 2 + j*width*4) = 0;
      *(imageThresh + i*4 + 3 + j*width*4) = 0;      
 //     if(( hue > 170 && hue < 190 && sat > 0.7) ) {//|| (hue > 330 && hue < 360))
      if(( hue > 50 && hue < 70 && sat > 0.7) ) {//|| (hue > 330 && hue < 360))
        *(imageThresh + i*4 + 1 + j*width*4) = 250;
        *(imageThresh + i*4 + 2 + j*width*4) = 250;
        *(imageThresh + i*4 + 3 + j*width*4) = 250;  	
        count++;
      }
    }
        
  
  }
  if(DEBUG)printf("Min sat = %f, max sat = %f\n",minsat,maxsat);
  return count;
  
}

int getAvLocation(unsigned char *image, int width, int height){

   //int row = height/2;
   int indexSum = 0;
   int indexAv = 0;
   int count = 0;
   for (int i = 0; i < width ; i++) { 
     if(*(image + i*4 + 1 + (height/2)*width*4) == 250) {
       indexSum += i; 
       count++;
     }
   }
 //  printf("IndexSum = %d\n",indexSum);
   if(count >0) indexAv = indexSum/count;
   return indexAv;   
} 