// ==================================================================
//
// CBP_ePuck_LinearCamera_1.c
//
// 30-12-20
//
//
// ==================================================================

// Included libraries
#include <webots/camera.h>
#include <webots/display.h>
#include <webots/robot.h>

#include <stdlib.h>
#include <stdio.h>

#include "CBP_1421_Helper1.h"
#include "CBP_1421_Helper2.h"

// Global defines
#define TIME_STEP 16
#define WHEEL_RADIUS 0.0205
#define AXLE_LENGTH 0.053
#define MAX_SPEED 6.28

// Variables related to the camera and extra display
WbDeviceTag cam;
static WbDeviceTag display1;
unsigned short width, height;

double omegaL, omegaR;

// Function to set up the camera
void init_camera(){

  cam = wb_robot_get_device("camera");
  wb_camera_enable(cam, TIME_STEP);
  width = wb_camera_get_width(cam);
  height = wb_camera_get_height(cam);
  printf("Camera width = %d, height = %d\n",width,height);
  // get the display device
  display1 = wb_robot_get_device("display");

}
 
// -------------------------------------------------------------------

int main() {

  int nr_pels_detected;
  
  wb_robot_init();
  
  cbp_motors_init();
  init_camera();

  unsigned char *lineImage = (unsigned char *)malloc(sizeof(unsigned char) * width * height * 8);

  while (wb_robot_step(TIME_STEP) != -1) {
  
    const unsigned char *image;
 
    image = wb_camera_get_image(cam);

    // 1. Segment the image looking for yellow. In CBP_Helper_2.c
    nr_pels_detected = imageSegment(image,lineImage, width, height);
    printf("nr_pels_detected = %d\n",nr_pels_detected);
    WbImageRef iref = wb_display_image_new(display1, width, height, lineImage, WB_IMAGE_BGRA);
    wb_display_image_paste(display1, iref, 0, 0, false);
    
    // 2. Generate control signal from image
    double line_center = (double)getAvLocation(lineImage,width,height);
    
    double gain = 1.0;
    
    // Complete the line below
    // double error = 
    // uncomment the two following lines
    // printf("loc = %f, percent error = %f\n",line_center,error*100);      
    //if(nr_pels_detected < 10) error = 0;
     
    // Complete the lines below
    //double fwdFactor = ??;
    //omegaL = (fwdFactor + ??)*MAX_SPEED;
    //omegaR = (fwdFactor + ??)*MAX_SPEED;

    
    cbp_motors_set_velocity(omegaL,omegaR);
        
  }
  free(lineImage);
  wb_robot_cleanup();

  return 0;
}

// -------------------------------------------------------------------
